'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _XHRHandler = require('./XHRHandler');

var _XHRHandler2 = _interopRequireDefault(_XHRHandler);

var _Client2 = require('./Client');

var _Client3 = _interopRequireDefault(_Client2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Default implementation of client. Client invokes handler to handle requests.
 */
var DefaultClient = function (_Client) {
  (0, _inherits3.default)(DefaultClient, _Client);

  function DefaultClient() {
    (0, _classCallCheck3.default)(this, DefaultClient);
    return (0, _possibleConstructorReturn3.default)(this, (DefaultClient.__proto__ || (0, _getPrototypeOf2.default)(DefaultClient)).apply(this, arguments));
  }

  (0, _createClass3.default)(DefaultClient, [{
    key: 'handler',

    /**
     * Getter for handler. Provides default handler if undefined.
     * @return {Handler} Handles requests
     */
    get: function get() {
      if (typeof this._handler === 'undefined') {
        this._handler = new _XHRHandler2.default();
      }
      return this._handler;
    }
    /**
     * Setter for handler.
     * @param  {Handler} handler Handles requests
     */
    ,
    set: function set(handler) {
      this._handler = handler;
    }
  }]);
  return DefaultClient;
}(_Client3.default);

exports.default = DefaultClient;