"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Default implementation for clients
 */
var Client = function () {
  /**
   *  Create client
   * @param  {Handler} handler Handler to handle request
   * @return {Client}
   */
  function Client(handler) {
    (0, _classCallCheck3.default)(this, Client);

    this.handler = handler;
  }
  /**
   * Invoke request on handler
   * @param  {Request} request Request to handle
   */


  (0, _createClass3.default)(Client, [{
    key: "invoke",
    value: function invoke(request) {
      this.handler.perform(request);
    }
  }]);
  return Client;
}();

exports.default = Client;